#!/usr/bin/env python
# -*- Coding: utf-8 -*-

import md5
import random
import web
import pyweblib.session
import shelve
import smtplib
import time


def is_valid(name, password):

	userdata = web.select('users', where='name="'+name+'" and active=1 and id!=1')

	try:
		userdata = userdata[0]
	except IndexError:
		return False


	m = md5.new()
	m.update(password)
	password = m.hexdigest()		

	if password == userdata['password']: # Password is valid
		
		websession = getWebSession()

		id = websession.newSession()
		web.setcookie('session', id) # writing sessionid to cookie

		# writing data to session
		data = dict()
		data['userid'] = userdata['id']
		data['username'] = userdata['name']
		data['admin'] = userdata['admin']
		websession.storeSession(id, data)

		return True
	else:
		return False



def valid_cookie():
	
	cookie = web.cookies()
	websession = getWebSession()
	
	try:
		id = cookie['session']
	except KeyError:
		return False

	try:
		websession.retrieveSession(session_id=cookie['session'])
	except pyweblib.session.InvalidSessionId:
		web.setcookie('session', '')
		return False
	except pyweblib.session.BadSessionId:
		web.setcookie('session', '')
		return False


	return True





def is_admin():
	
	session = getSession()
	if session['admin'] == 1:
		return True
	else:
		return False




def getWebSession():

	return pyweblib.session.WebSession (
		dictobj=shelve.open('/tmp/todotool-pyweblib.session','c'),
		expireDeactivate=2700,
		expireRemove=2700
	)



def getSession():
	cookie = web.cookies()
	websession = getWebSession()
	return websession.retrieveSession(cookie['session'])	



def sendNewTodoMail(fromid, todoid):
	
	sender = web.select('users', where='id='+str(fromid), limit=1)
	todo = web.select('todos', where='id='+str(todoid))

	sender = sender[0]
	todo = todo[0]

	recipient = web.select('users', where='id='+str(todo['who']), limit=1)
	recipient = recipient[0]

	# do not send a mail for default user
	if recipient['id'] == 1:
		return 

	body = ''
	body += 'From: ' + sender['name'] + ' <' + sender['mail'] + '>\n'
	body += 'To: ' + recipient['mail'] + '\n'
	body += 'X-TODO: Yes\n'
	body += 'Content-Type: text/plain;       charset="utf-8"\n'
	body += 'Subject: [Freitagsrunde | NEW TODO] ' + todo['title'] + '\n'
	body += 'Date: ' + time.strftime('%a, %d %b %Y %H:%M:%S %Z +0200') + '\n'
	body += todo['task'] + '\n'
	body += '\n----------------------------------------------------\n'
	body += 'See: ' + web.ctx.home + '/todo/show/' + str(todo['id'])

	server = smtplib.SMTP('localhost')
	server.sendmail(sender['mail'], recipient['mail'], body)
	server.quit()
	










