#!/usr/bin/env python
# -*- Coding: utf-8 -*-

import config

if config.mode == 'productive':
	import cgitb; cgitb.enable()
	import sys

import web
import todo
import user
import todolib



urls = (

	'/','user.validate',

	'/todo/list', 'todo.list',
	'/todo/add', 'todo.add',
	'/todo/delete/(.*)', 'todo.delete',
	'/todo/show/(.*)', 'todo.show',
	'/todo/edit/(.*)', 'todo.edit',	


	'/user/list', 'user.list',
	'/user/edit/(.*)', 'user.edit',
	'/user/add', 'user.add',
	'/user/add/', 'user.add',
	'/user/delete/(.*)', 'user.delete',
	'/user/deactivate/(.*)', 'user.deactivate',
	'/user/activate/(.*)', 'user.activate',
	'/user/validate','user.validate',
	'/user/validate/','user.validate',
	'/user/logout', 'user.logout',
	'/user/register', 'user.register',	
	'/error', 'error',

	'/my', 'user.my',
	'/my/todo/list', 'user.my',
	'/my/todo/edit/(.*)', 'todo.edit',
	'/my/todo/delete/(.*)', 'todo.delete',
	'/my/user/edit/(.*)', 'user.edit',
	'/my/misc', 'user.misc',


	'/style.css', 'style',

	'/img/logo.gif', 'logo',
	'/img/logout.png', 'icon_logout',
	'/img/add.png', 'icon_add',
	'/img/list.png', 'icon_list',
	'/img/edit.png', 'icon_edit',
	'/img/deactivate.png', 'icon_deactivate',
	'/img/activate.png', 'icon_activate',
	'/img/delete.png', 'icon_delete',
	'/img/home.png', 'icon_home',
	'/img/feet.png', 'icon_feet',
	'/img/login.png', 'icon_login',

)


# MySQL-Settings
if config.dbtype == 'mysql':
	web.db_parameters = dict(dbn='mysql', user=config.mysqluser, pw=config.mysqlpassword, db=config.mysqldbname)


# Stylesheet		
class style:
	def GET(self):
		print open('style.css').read()


# Errorpage
class error:
	def GET(self, message='ERROR', description='An error occured.'):

		web.render('error.html')



# Images
class logo:
	def GET(self):
		print open('img/logo.gif').read()

class icon_logout:
	def GET(self):
		print open('img/logout.png').read()

class icon_add:
	def GET(self):
		print open('img/add.png').read()

class icon_list:
	def GET(self):
		print open('img/list.png').read()

class icon_edit:
	def GET(self):
		print open('img/edit.png').read()

class icon_delete:
	def GET(self):
		print open('img/delete.png').read()

class icon_deactivate:
	def GET(self):
		print open('img/deactivate.png').read()

class icon_activate:
	def GET(self):
		print open('img/activate.png').read()

class icon_home:
	def GET(self):
		print open('img/home.png').read()

class icon_feet:
	def GET(self):
		print open('img/feet.png').read()


class icon_login:
	def GET(self):
		print open('img/login.png').read()


# for cgi use
def cgidebugerror():
    """                                                                         
    """
    _wrappedstdout = sys.stdout

    sys.stdout = web._oldstdout
    cgitb.handler()

    sys.stdout = _wrappedstdout


if config.mode == 'productive':
	web.internalerror = cgidebugerror
else:
	web.internalerror = web.debugerror


if __name__ == '__main__':

	if config.mode == 'produktive':
		web.run(urls)
	if config.mode == 'development':
		web.run(urls, web.reloader)
	else:
		print 'Config-ERROR: Please check mode variable in config.py'












