#!/usr/bin/env python
# -*- Coding: utf-8 -*-

import web, todo, todolib, todotool
import md5, random
import pyweblib.session, shelve


class list:
	def GET(self, message=None):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect=web.ctx.path, message='Please log in...')
			return

		users = web.select('users', order="name")

		action = '/user/delete'
		web.render('userlist.html')


class add:
	def GET(self):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect=web.ctx.path, message='Please log in...')
			return
		
		# Need admin rights
		if todolib.is_admin() == False:
			todotool.error().GET(message='Permission denied.', description='You are not admin.')
			return

		namevalue = ''
		passwordvalue = ''
		mailvalue = ''
		
		headline = 'Add a new user...'

		action = '/user/add'
		message = None
		web.render('userform.html')


	def POST(self):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect=web.ctx.path, message='Please log in...')
			return


		i = web.input()

		# Errors
		namevalue = i.name
		mailvalue = i.mail
		passwordvalue = i.password0
		
		headline = 'Add a new user...'
		action = '/user/add'


		# name
		if i.name == '':
			namevalue = ''
			message = 'Please enter your name.'
			web.render('userform.html')
			return

		# mail
		if i.mail == '':
			mailvalue = ''

			message = 'Please enter your mailadress.'
			web.render('userform.html')
			return

		# password-equality	
		if (i.password0 != i.password1) or i.password0 == '':
			passwordvalue = ''

			message = 'Passwords must be equal and not empty.'
			web.render('userform.html')
			return
		


		# Check for uniqueness of name and mailadress
		users = web.select('users')

		for user in users:

			if user.name.lower() == i.name.lower():
				namevalue = ''
				message = 'Name is not unique.'
				web.render('userform.html')
				return

			if user.mail.lower() == i.mail.lower():
				mailvalue = ''
				message = 'Mailadress is not unique.'
				web.render('userform.html')
				return
		
		# encrypting password
		m = md5.new()
		m.update(i.password0)
		md5password = m.hexdigest()

		web.insert('users', name=i.name, mail=i.mail, password=md5password, active=1)
		
		list().GET('User "' + i.name + '" added.')



class delete:
	def GET(self, name):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect=web.ctx.path, message='Please log in...')
			return
		
		# Need admin rights
		if todolib.is_admin() == False:
			todotool.error().GET(message='Permission denied.', description='You are not admin.')
			return


		try:
			int(name)
		except ValueError:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return
		

		
		query = web.delete('users', where='id='+name)
		
		if query == 0:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return
		

		list().GET(message='User width id ' + name + ' deleted.')




class edit:
	def GET(self, name, message=None):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect=web.ctx.path, message='Please log in...')
			return

		# given argument is not a number
		try:
			name = int(name)
		except ValueError:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return

		# Not enough rights to edit
		if ((todolib.getSession()['userid'] != name) and (todolib.is_admin() == False)):
			todotool.error().GET(message='Permission denied.', description='You are only allowed to edit userdata if you are admin or you are the user itself.')
			return

		# Select userdata
		query = web.select('users', where='id='+str(name), limit='1')

		query = query[0]

		namevalue = query['name']
		mailvalue = query['mail']
		passwordvalue = ''
		


		action = web.ctx.path
		headline = 'Preferences'
		web.render('userform.html')





	def POST(self, name):
		
		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect=web.ctx.path, message='Please log in...')
			return

		# given argument is not a number
		try:
			name = int(name)
		except Exception:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return

		# Not enough rights to edit
		if ((todolib.getSession()['userid'] != name) and (todolib.is_admin() == False)):
			todotool.error().GET(message='Permission denied.', description='You are only allowed to edit userdata if you are admin or you are the user itself.')
			return


		i = web.input()

		action = web.ctx.path
		headline = 'Preferences'
		namevalue = i['name']
		mailvalue = i['mail']
		passwordvalue = i['password0']

		
		# name
		if i.name == '':
			namevalue = ''
			message = 'Please enter your name.'
			web.render('userform.html')
			return

		# mail
		if (i.mail == '') and (name != 1):
			mailvalue = ''

			message = 'Please enter your mailadress.'
			web.render('userform.html')
			return

		# password-equality	
		if (i.password0 != i.password1):
			passwordvalue = ''

			message = 'Passwords must be equal.'
			web.render('userform.html')
			return


		# deleting values that should be unique
		query = web.update('users', where='id='+str(name), name='', mail='')

		if query == 0:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return


		# Check for uniqueness of name and mailadress
		users = web.select('users')

		for user in users:

			if (user.name.lower() == i.name.lower()) and (name != 1):
				namevalue = ''
				message = 'Name is not unique.'
				web.render('userform.html')
				return

			if (user.mail.lower() == i.mail.lower()) and (name != 1):
				mailvalue = ''
				message = 'Mailadress is not unique.'
				web.render('userform.html')
				return


		# Updating values
		query = web.update('users', where='id='+str(name), name=i.name, mail=i.mail)

		if query == 0:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return

		message = 'Changes saved.'


		# Updating password if wanted
		if i.password0 != '':
			m = md5.new()
			m.update(i.password0)
			md5password = m.hexdigest()

			query = web.update('users', where='id='+str(name), password=md5password)

			if query == 0:
				todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
				return


			message += ' (Remember the new password)'

		else:
			message += ' (Password is the same)'


		if web.ctx.path.split('/')[1] == 'my':
			edit().GET(name=name, message=message)
		else:
			list().GET(message=message)





class deactivate:
	def GET(self, name):
		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect=web.ctx.path, message='Please log in...')
			return

		# Need admin rights
		if todolib.is_admin() == False:
			todotool.error().GET(message='Permission denied.', description='You are not admin.')
			return

		try:
			int(name)
		except ValueError:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return

		query = web.update('users', where='id='+name, active=0)

		if query == 0:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return

		list().GET('User with id ' + name + ' deactivated.')



class activate:
	def GET(self, name):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect=web.ctx.path, message='Please log in...')
			return
	
		# Need admin rights
		if todolib.is_admin() == False:
			todotool.error().GET(message='Permission denied.', description='You are not admin.')
			return


		try:
			int(name)
		except ValueError:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return


		query = web.update('users', where='id='+name, active=1)

		if query == 0:
			todotool.error().GET(message='Page does not exist.', description='Do not edit the URL on your own.')
			return


		list().GET('User with id ' + name + ' activated.')




class validate:
	def GET(self, redirect='/todo/list', message=None):		

		if todolib.valid_cookie() == True:
			web.seeother(redirect)
		else:
			web.render('uservalidate.html')



	def POST(self):

		i = web.input()

		if todolib.is_valid(i.name, i.password):

			if i.redirect == '/user/logout':
				i.redirect = '/'
	
			web.seeother('/todo/list')

		else:
			validate().GET(message='Access denied.')





class logout:
	def GET(self, message='Logged out.'):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect='/', message='Please log in...')
			return

		websession = todolib.getWebSession()

		c = web.cookies()

		websession.deleteSession(c['session'])

		c['session'] = ''

		validate().GET(message)




class my:
	def GET(self, message=None):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect='/', message='Please log in...')
			return


		todo.list().GET()




class misc:
	def GET(self):

		# Authentification
		if todolib.valid_cookie() == False:
			validate().GET(redirect='/', message='Please log in...')
			return

		print 'Cookie Content:'
		for i in web.cookies().items():
			print i

		print '\n'

		print 'Session Content:'
		for i in todolib.getSession().items():
			print i



class register:
	def GET(self):

		message = None
		headline = 'Register...'
		action = web.ctx.path

		namevalue = ''
		mailvalue = ''
		passwordvalue = ''

		web.render('userform.html')



	def POST(self):
		i = web.input()

		# Errors
		namevalue = i.name
		mailvalue = i.mail
		passwordvalue = i.password0
		
		headline = 'Register'
		action = web.ctx.path


		# name
		if i.name == '':
			namevalue = ''
			message = 'Please enter your name.'
			web.render('userform.html')
			return

		# mail
		if i.mail == '':
			mailvalue = ''

			message = 'Please enter your mailadress.'
			web.render('userform.html')
			return

		# password-equality	
		if (i.password0 != i.password1) or i.password0 == '':
			passwordvalue = ''

			message = 'Passwords must be equal and not empty.'
			web.render('userform.html')
			return
		


		# Check for uniqueness of name and mailadress
		users = web.select('users')

		for user in users:

			if user.name.lower() == i.name.lower():
				namevalue = ''
				message = 'Name is not unique.'
				web.render('userform.html')
				return

			if user.mail.lower() == i.mail.lower():
				mailvalue = ''
				message = 'Mailadress is not unique.'
				web.render('userform.html')
				return
		
		# encrypting password
		m = md5.new()
		m.update(i.password0)
		md5password = m.hexdigest()

		web.insert('users', name=i.name, mail=i.mail, password=md5password, active=0)
		
		todotool.error().GET(message='Registered successfully.', description='Please wait till a administrator has activated you ')


















